<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="规则名称" prop="ruleName">
        <el-input v-model="formData.ruleName" placeholder="请输入规则名称" />
      </el-form-item>
      <el-form-item label="个税类型 1 工资薪金所得税 2 劳务报酬所得税 3 不计税" prop="taxType">
        <el-select v-model="formData.taxType" placeholder="请选择个税类型 1 工资薪金所得税 2 劳务报酬所得税 3 不计税">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="是否计税 0 否 1 是" prop="isTax">
        <el-input v-model="formData.isTax" placeholder="请输入是否计税 0 否 1 是" />
      </el-form-item>
      <el-form-item label="起征点" prop="markingPoint">
        <el-input v-model="formData.markingPoint" placeholder="请输入起征点" />
      </el-form-item>
      <el-form-item label="个税结果(保留小数点)" prop="decimalPoint">
        <el-input v-model="formData.decimalPoint" placeholder="请输入个税结果(保留小数点)" />
      </el-form-item>
      <el-form-item label="计税周期类型 1 上年12月到今年11月（对应的工资发放方式为次月发上月工资） 2 今年1月到12月（对应的工资发放方式为当月发当月工资）" prop="cycleType">
        <el-select v-model="formData.cycleType" placeholder="请选择计税周期类型 1 上年12月到今年11月（对应的工资发放方式为次月发上月工资） 2 今年1月到12月（对应的工资发放方式为当月发当月工资）">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { SalaryTaxRuleApi, SalaryTaxRule } from '@/api/hr/salarytaxrule'

/** 计税规则 表单 */
defineOptions({ name: 'SalaryTaxRuleForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  ruleId: undefined,
  ruleName: undefined,
  taxType: undefined,
  isTax: undefined,
  markingPoint: undefined,
  decimalPoint: undefined,
  cycleType: undefined
})
const formRules = reactive({
  ruleName: [{ required: true, message: '规则名称不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await SalaryTaxRuleApi.getSalaryTaxRule(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as SalaryTaxRule
    if (formType.value === 'create') {
      await SalaryTaxRuleApi.createSalaryTaxRule(data)
      message.success(t('common.createSuccess'))
    } else {
      await SalaryTaxRuleApi.updateSalaryTaxRule(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    ruleId: undefined,
    ruleName: undefined,
    taxType: undefined,
    isTax: undefined,
    markingPoint: undefined,
    decimalPoint: undefined,
    cycleType: undefined
  }
  formRef.value?.resetFields()
}
</script>